获取我们在 Firebase 峰会上发布的所有信息,了解 Firebase 可如何帮助您加快应用开发速度并满怀信心地运行应用。了解详情

开始使用 Firebase Crashlytics

本快速入门介绍了如何使用 Firebase Crashlytics SDK 在您的应用中设置 Firebase Crashlytics,以便您可以在 Firebase 控制台中获得全面的崩溃报告。使用适用于 Android 的 Crashlytics,您可以获得有关崩溃、非致命错误和“应用程序无响应”(ANR) 错误的报告。

设置 Crashlytics 需要在 Firebase 控制台和您的 IDE 中执行任务(例如添加 Firebase 配置文件和 Crashlytics SDK)。要完成设置,您需要强制测试崩溃以将您的第一个崩溃报告发送到 Firebase。

在你开始之前

  1. 如果您还没有,请将 Firebase 添加到您的 Android 项目中。如果您没有 Android 应用程序,可以下载示例应用程序

  2. 推荐:要获得无崩溃用户、面包屑日志和速度警报等功能,您需要在 Firebase 项目中启用 Google Analytics。

    • 如果您现有的 Firebase 项目没有启用 Google Analytics,您可以从 Firebase 控制台中 >项目设置集成选项卡启用 Google Analytics。

    • 如果您要创建新的 Firebase 项目,请在项目创建工作流程中启用 Google Analytics。

第 1 步:将 Crashlytics SDK 添加到您的应用

在您的模块(应用程序级)Gradle 文件(通常为<project>/<app-module>/build.gradle )中,添加 Crashlytics Android 库的依赖项。我们建议使用Firebase Android BoM来控制库版本。

为了获得最佳的 Crashlytics 体验,我们建议在您的 Firebase 项目中启用 Google Analytics ,并将适用于 Google Analytics 的 Firebase SDK 添加到您的应用程序中。

Kotlin+KTX

dependencies {
    // Import the BoM for the Firebase platform
    implementation platform('com.google.firebase:firebase-bom:31.2.0')

    // Add the dependencies for the Crashlytics and Analytics libraries
    // When using the BoM, you don't specify versions in Firebase library dependencies
    implementation 'com.google.firebase:firebase-crashlytics-ktx'
    implementation 'com.google.firebase:firebase-analytics-ktx'
}

通过使用Firebase Android BoM ,您的应用将始终使用兼容版本的 Firebase Android 库。

(备选)使用 BoM 的情况下添加 Firebase 库依赖项

如果您选择不使用 Firebase BoM,则必须在其依赖项行中指定每个 Firebase 库版本。

请注意,如果您在应用中使用多个Firebase 库,我们强烈建议您使用 BoM 来管理库版本,以确保所有版本都兼容。

dependencies {
    // Add the dependencies for the Crashlytics and Analytics libraries
    // When NOT using the BoM, you must specify versions in Firebase library dependencies
    implementation 'com.google.firebase:firebase-crashlytics-ktx:18.3.3'
    implementation 'com.google.firebase:firebase-analytics-ktx:21.2.0'
}

Java

dependencies {
    // Import the BoM for the Firebase platform
    implementation platform('com.google.firebase:firebase-bom:31.2.0')

    // Add the dependencies for the Crashlytics and Analytics libraries
    // When using the BoM, you don't specify versions in Firebase library dependencies
    implementation 'com.google.firebase:firebase-crashlytics'
    implementation 'com.google.firebase:firebase-analytics'
}

通过使用Firebase Android BoM ,您的应用将始终使用兼容版本的 Firebase Android 库。

(备选)使用 BoM 的情况下添加 Firebase 库依赖项

如果您选择不使用 Firebase BoM,则必须在其依赖项行中指定每个 Firebase 库版本。

请注意,如果您在应用中使用多个Firebase 库,我们强烈建议您使用 BoM 来管理库版本,以确保所有版本都兼容。

dependencies {
    // Add the dependencies for the Crashlytics and Analytics libraries
    // When NOT using the BoM, you must specify versions in Firebase library dependencies
    implementation 'com.google.firebase:firebase-crashlytics:18.3.3'
    implementation 'com.google.firebase:firebase-analytics:21.2.0'
}

第 2 步:将 Crashlytics Gradle 插件添加到您的应用

  1. 根级(项目级) Gradle 文件 ( <project>/build.gradle ) 中,将 Crashlytics Gradle 插件添加为 buildscript 依赖项:

    buildscript {
        repositories {
          // Make sure that you have the following two repositories
          google()  // Google's Maven repository
          mavenCentral()  // Maven Central repository
        }
    
        dependencies {
            ...
            classpath 'com.android.tools.build:gradle:7.2.0'
    
            // Make sure that you have the Google services Gradle plugin dependency
            classpath 'com.google.gms:google-services:4.3.15'
    
            // Add the dependency for the Crashlytics Gradle plugin
            classpath 'com.google.firebase:firebase-crashlytics-gradle:2.9.2'
        }
    }
  2. 在您的模块(应用程序级) Gradle 文件(通常是<project>/<app-module>/build.gradle )中,添加 Crashlytics Gradle 插件:

    plugins {
        id 'com.android.application'
    
        // Make sure that you have the Google services Gradle plugin
        id 'com.google.gms.google-services'
    
        // Add the Crashlytics Gradle plugin
        id 'com.google.firebase.crashlytics'
        ...
    }

第 3 步:强制测试崩溃以完成设置

要完成 Crashlytics 的设置并在 Firebase 控制台的 Crashlytics 仪表板中查看初始数据,您需要强制测试崩溃。

  1. 将可用于强制测试崩溃的代码添加到您的应用程序。

    您可以在应用的MainActivity中使用以下代码向您的应用添加一个按钮,按下该按钮会导致崩溃。该按钮标记为“测试崩溃”。

    Kotlin+KTX

    val crashButton = Button(this)
    crashButton.text = "Test Crash"
    crashButton.setOnClickListener {
       throw RuntimeException("Test Crash") // Force a crash
    }
    
    addContentView(crashButton, ViewGroup.LayoutParams(
           ViewGroup.LayoutParams.MATCH_PARENT,
           ViewGroup.LayoutParams.WRAP_CONTENT))
    

    Java

    Button crashButton = new Button(this);
    crashButton.setText("Test Crash");
    crashButton.setOnClickListener(new View.OnClickListener() {
       public void onClick(View view) {
           throw new RuntimeException("Test Crash"); // Force a crash
       }
    });
    
    addContentView(crashButton, new ViewGroup.LayoutParams(
           ViewGroup.LayoutParams.MATCH_PARENT,
           ViewGroup.LayoutParams.WRAP_CONTENT));
    
  2. 构建并运行您的应用程序。

  3. 强制测试崩溃以发送您的应用程序的第一个崩溃报告:

    1. 从您的测试设备或模拟器打开您的应用程序。

    2. 在您的应用中,按下您使用上述代码添加的“测试崩溃”按钮。

    3. 在您的应用程序崩溃后,重新启动它,以便您的应用程序可以将崩溃报告发送到 Firebase。

  4. 转到 Firebase 控制台的Crashlytics 仪表板以查看您的测试崩溃。

    如果您刷新了控制台,但五分钟后仍未看到测试崩溃,请启用调试日志记录以查看您的应用程序是否正在发送崩溃报告。


就是这样! Crashlytics 现在正在监控您的应用程序是否存在崩溃、非致命错误和 ANR。访问Crashlytics 仪表板以查看和调查您的所有报告和统计信息。

下一步

  • 与 Google Play 集成,以便您可以直接在 Crashlytics 仪表板中按 Google Play 跟踪过滤 Android 应用程序的崩溃报告。这使您可以更好地将仪表板集中在特定构建上。
  • 在 Android Studio 中,查看和过滤 Crashlytics 数据。
    • 使用 Android Studio 中的App Quality Insights (AQI) 窗口查看代码旁边的 Crashlytics 数据——无需在 Crashlytics 仪表板和 IDE 之间来回跳转即可开始调试最重要的问题。
    • 在 Android Studio 的 Electric Eel 版本(稳定版)中访问 AQI 窗口,或在 Flamingo(测试版)中试用新的 AQI 功能下载所需的 Android Studio 版本。
    • 在 Android Studio 文档中了解如何使用 AQI 窗口
    • 我们很乐意听取您的意见!通过提交错误报告向我们发送有关 AQI 窗口的反馈。